/* Copyright (c) 1992 by AT&T Bell Laboratories. */
/* Advanced C++ Programming Styles and Idioms */
/* James O. Coplien */
/* All rights reserved. */

//************************************************************//
//                                                            //
//         :     T O P . C                                //
//                                                            //
//         Ŭ Top  ڵ                             //
//                                                            //
//************************************************************//

#include "k.h"
#include <sys/types.h>

Top *
Top::doit() {
    // Ŭ  ϱ   ֵ ϸ鼭 ڰ 
    //  ֵ   ʴ Լ
    return 0;
}

int
Top::compareFuncs(int vtblindex, vptp, vptp fptr) {
    //   Լ  Ǵϱ   Լ  ߻ȭ Ѵ.
    // ù° Լ ʹ vtbl ΰ Լ ͷ Ư Ѵ.
    // ° ܼ Լ ͸ Ѵ.
    // ̷ Ű Ȱ ýۿ   ִ.
    // ⼭ ù  Լ ּҴ  ʴ´.
    return vtblindex == (int)fptr;
}

mptr *
Top::findVtblEntry(vptp f) {
    // "" ü  Լ ̺ 켭 f Ű
    //  Լ ͸ ã  Լ mptr ü
    // ּҸ ȯѴ( Լ ̺ Ʈ Ϻ ).

    // mpp vtbl  ּҰ  ̴. vtbl ʹ
    // ִ  ü    ̸ 
    //  ִ( ü Top ӹ޴´).
    mptr ** mpp = (mptr**) this;

    //  ü ۿ ġ vtbl ּҸ  
    //   ּҸ  Ѵ. 
    mptr * vtbl = *mpp;

    printf("Top::findVtblEntry(%d):  vtbl = 0x%x\n", f, vtbl);

    // ڽ vtbl  ˻Ѵ. 0 ִ Ʈ
    //  ǥ ̸, 0° Ʈ  ʴ´.
    // û Լ 캸.
    for(int i = 1; vtbl[i].f; ++i ) {
        if (compareFuncs(i, vtbl[i].f, f)) {
            return vtbl + i;
        }
    }
    return 0;
}

// C 󿡼  ܺ "load" Լ 
extern "C" vptp load(const char *);

void
Top::update(    String filename,
                String fname,
                const char *const TypedefSpec) {

    // Լ filename Լ fname  ̸ ޸𸮿
    // Ѵ.  Ű   Լ 
    //  Ÿ Ѵ. ̴ Լ ε 쿡
    // ʿϴ.  Լ ̺ ⿡  Ѵ.
    //   Լ   ִ.

    const String temp = "/tmp";

    printf("Top::update(\"%s\", \"%s\", \"%s\")\n",
        (const char *)filename, (const char *)fname,
        (const char *)TypedefSpec);
    String prepname = temp + "/" + "t.c";
    String Typedef, cast = "";
    if (strlen(TypedefSpec)) {
        Typedef = String("// TYPE used to disambiguate\
        overloaded function\n\t\t\ttypedef ") + TypedefSpec;
    } else {
        Typedef = "typedef vptp TYPE";
        cast = "(vptp)";
    }
    // 
    // prepname .  Լ ϴ Լ ּҸ
    // ȯϴ  Լ̴.
    FILE *tempFile = fopen(prepname, "w");
    fprintf(tempFile, "#\
        include \"includes.h\"\n\
        extern vptp functionAddress() {\n\
            %s;\n\
            TYPE retval = %s&%s;\n\
            return (vptp)retval;\n\
        }\n",
        (const char*)Typedef,
        (const char *)cast,
        (const char*)fname);
    fclose(tempFile);

    //  Լ Ѵ.
    String command = String("DIR=`pwd`; cd ") + temp + ";\
        CC +e0 -I$DIR -c -g " + prepname;
    system(command);
    unlink(prepname);
    String objectname =
            prepname(0, prepname.length() - 2) + ".o";

    //  Լ Ѵ. load ο Լ ּҸ ȯ ϶.
    vvptp findfunc = (vvptp)load(objectname);
    unlink(objectname);
    printf("Top::update: calling findVtblEntry(%d)\n",
                    (*findfunc)());

    //  ùٸ vtbl Ʈ Ŭ vtbl ο ãҴ.
    // findVtblEntry  Լ ã ִ ϱ 
    //  Լ ȣѴ.
    mptr *vtblEntry = findVtblEntry((*findfunc)());

    //  Ӱ ǿø Լ ϰ  Լ ּҸ
    // vtbl Ʈ Ѵ.
    printf("Top::update: old vtblEntry->f = 0x%x\n",
        vtblEntry->f);
    printf("Top::update: calling load(\"%s\")\n",
        (const char *) filename);
    vtblEntry->f = load(filename);
    printf("Top::update: complete, new vtblEntry->f = 0x%x\n",
        vtblEntry->f);
}
