/* Copyright (c) 1992 by AT&T Bell Laboratories. */
/* Advanced C++ Programming Styles and Idioms */
/* James O. Coplien */
/* All rights reserved. */

class Letter: public Thing {
public:
    /*    ڰ ⿡ δ.  ->  
     * ̷  Envelope 䳻 ȵȴٴ  ָ϶.
     * , Envelop rep ʵ  Ÿ οؾ߸ Ѵ.
     *  ڴ ⿡ , Envelope ִ.
     * ȯ Ÿ  Ÿ, Ÿ Envelope, Ÿ Envelope&, ü
     * ڷ Ÿ  ϳ Ǿ Ѵ.
     */
    virtual void send(String name, String address);
    virtual double postage();
    // virtual ȯ_Ÿ __Լ
    // . . . .
    virtual Envelope make();          // 
    virtual Envelope make(double);    //  ٸ 
    virtual Envelope make(int days, double weight);
    virtual Thing *cutover(Thing*);  //  ð  Լ
    Letter() { }
    ~Letter() { }
    Thing *type();
protected:
    friend class Envelope;
    double ounces;
    static void *operator new(size_t l) {
        return ::operator new(l);
    }
    static void operator delete(void *p) {
        ::operator delete(p);
    }
    String name, address;
    // . . . .
private:
    // . . . .
};
