/* Copyright (c) 2003 by Hanbit Media Co. All rights reserved*/
/* Lee, Hae-Young(hae_lee@hanmail.net) */
/* Advanced C++ Programming Styles and Idioms, exercise 4-6 */

// correct 4-6-a.cpp 

#include <iostream.h>

class A {
public:
    A(int i = 0) { a = i; }
    A& operator=(A& x) { a = x.a; return *this; }

    void print() { cout << "A.a = " << a << endl; }

protected:
    int a;
};

class B: public A {
public:
    B(int i = 0): A(i) { b = i; }
    B& operator=(B& x) { A::operator=(x); b=x.b; return *this; }

    void print() { A::print(); cout << "B.b = " << b << endl; }
private:
    int b;
};

int main() {
    B b1, b2(2);
    b1 = b2;

    cout << "b1 values" << endl;
    b1.print();

    cout << "b2 values" << endl;
    b2.print();

    return 0;
}
