/* Copyright (c) 1992 by AT&T Bell Laboratories. */
/* Advanced C++ Programming Styles and Idioms */
/* James O. Coplien */
/* All rights reserved. */

#include "3-14.h"

String *String::newlist = 0;

void String::operator delete(void *p) {
    String *s = (String *)p;
    s->freepointer = newlist;
    newlist = s;
}

void* String::operator new(size_t size) {
    if (size != sizeof(String)) {
        //  κ Ļ Ŭ(4) Կ ұϰ,
        // ش Ŭ new ڸ  ʾ 쿡 ʿϴ.
        //   String::operator delete ޸𸮸 ٽ ϴ
        //  ̷ ũⰡ    ó  ־ Ѵ.
        // :   ڵ忡 ϰ  ʴ.
        return malloc(size);
    } else if (!newlist) {
        int i;
        newlist = (String *)new char[100 * sizeof(String)];
        for (i = 0; i < 99; i++) {
            newlist[i].freepointer = &(newlist[i+1]);
        }
        newlist[i].freepointer =0;
    }
    String *savenew = newlist;
    newlist = newlist->freepointer;
    return savenew;
}
