/* Copyright (c) 1992 by AT&T Bell Laboratories. */
/* Advanced C++ Programming Styles and Idioms */
/* James O. Coplien */
/* All rights reserved. */

#include <stdio.h>

void f(int j) { /* . . . . */ }

class A {               //  Ŭ( Ŭ)
public:
    void f(int i) { printf("A::f %d\n", i); }
    // . . . .
};

class B: public A {     // Ļ Ŭ( Ŭ)
public:
    void f(double d) {  printf("B::f %f\n", d); }
    void g(int);
    // . . . .
};

void B::g(int k) {
    f(k);               // B::f(double) (double ° )
    A::f(k);            // A::f(int);
    this->A::f(k);      // A::f(int);
    ::f(k);             // ::f(int);
}

int main() {
    A *a;
    B *b;
    int i;
    // . . . .
    a->f(1);        // A::f(int)
    a->f(3.0);      // A::f(int)  (int(3.0)  )
    b->f(2);        // B::f(double) (double(2) ° )
    b->f(2.0);      // B::f(double)
    b->A::f(7.0);   // A::f(int) (int(7.0)  )
    b->g(10);       // B::g(int)
}
