/* Advanced C++ Programming Styles and Idioms */

#include <iostream.h>

class A { public: virutal void f(int); };
void A::f(int) { cout << "A::f\n"; }
class B: public A { public: void f(double); };
void B::f(int) { cout << "B::f\n"; }
class C: public B { public: virtual void f(int); };
void C::f(int) { cout << "C::f\n"; }

int main()
{
    A *a;
    B *b;
    C *c = new C;
    c->f(2);        // C::f
    c->f(2.0);      // C::f (int  )
    b = c;
    b->f(2);        // B::f (double ° )
    b->f(2.0);      // B::f
    a = c;
    a->f(2);        // C::f
    a->f(2.0);      // C::f (int  )
    return 0;
}
