/* Copyright (c) 1992 by AT&T Bell Laboratories. */
/* Advanced C++ Programming Styles and Idioms */
/* James O. Coplien */
/* All rights reserved. */

#ifndef _7_4_H_
#define _7_4_H_

template <class T> class ListItem;

template <class T> class List {
public:
    void sort();          // Ʈ 
    void put(T& t);
    T get();
    int element(const T&) const;
    int size() const;
    //  . .               // ٸ ִ 
    List() { head = 0; }  // ⺻ 
private:
    ListItem<T> *head;    // Ʈ Ӹ
};

template <class T> class ListItem {
friend class List<T>;
private:
    ListItem<T> *next;
    T *item;
    ~ListItem() { delete item; }
    ListItem(const ListItem<T> *n, T *i)
        { item=new T(*i); next=(ListItem<T>*)n; }
};

template <class T> T List<T>::get() {  // Ʈ Ӹ 
    T retval = *(head->item);
    ListItem<T> *temp = head;
    head = head->next;
    delete temp;
    return retval;
}

template <class T> void
List<T>::put(T& t) { head = new ListItem<T>(head, &t); }

#endif
