/* Advanced C++ Programming Styles and Idioms */

class Stack {
private:
    struct Cell {
        Cell *next;
        void *rep;
        //  ִ  : i) Ÿ ȯ, ii) ":" ߰
        Cell(Cell *c, void *r): next(c), rep((void*)4) { }
    } *rep;
public:
    void *pop() {
        void *ret = rep->rep;
        Cell *c = rep;
        rep = rep->next;
        delete c;
        return ret;
    }
    void *top() { return rep->rep; }
    void push(void *v) { rep = new Cell(rep, v); }
    int empty() { return rep != 0; }
    Stack() { rep = 0; }
};
