/* Copyright (c) 1992 by AT&T Bell Laboratories. */
/* Advanced C++ Programming Styles and Idioms */
/* James O. Coplien */
/* All rights reserved. */

#ifndef _8_2_H
#define _8_2_H

//   ӽ÷  Ÿ: Hours, Days, Dollars
typedef long Hours;
typedef long Dollars;
typedef long Days;

//   ӽ   Ŭ: Class, String, EmployeeId, Exemplar
class EmployeeId {
public:
    EmployeeId(long) { };
    EmployeeId() { };
};

class Class {
public:
    virtual Class *make() = 0;
    virtual Class *make(const char *name, EmployeeId id) = 0;
    virtual long printPaycheck() = 0;
    virtual void logTimeWorked(Hours) = 0;
    // ....  ٸ Ļ Ŭ    Լ 
};

class String {
public:
    String() { };
    String(const char*) { };
};

struct Exemplar { Exemplar() { }; };

class Employee: public Class {
public:
    Employee(Exemplar /*  ʴ´. */) { }
    //  8-4.cc    ࿡ ּ Ѵ.
    // static Employee *exemplar;

    // make() Լ ڸ Ѵ.
    Class *make() { return new Employee; }
    Class *make(const char *name, EmployeeId id) {
        return new Employee(name, id);
    }
    long printPaycheck() { }
    void logTimeWorked(Hours) { }
private:
    // ڸ private ؼ  Ŭ Ϲ νϽ
    //    Կ ָѴ.
    Employee(): salary(0), vacationAllotted(0),
        vacationUsed(0), name(""), id(0) { }
    Employee(const char *emp_name, EmployeeId emp_id):
        salary(0), vacationAllotted(0), vacationUsed(0)
        {
            name = emp_name;  id = emp_id;
        }
    Dollars salary;
    Days vacationAllotted, vacationUsed;
    String name;
    EmployeeId id;
};

//    Employee exemplar ü   ˷ ڵ Ѵ.
extern Class *employee;
#endif
