/* Copyright (c) 2003 by Hanbit Media Co. All rights reserved*/
/* Lee, Hae-Young(hae_lee@hanmail.net) */
/* Advanced C++ Programming Styles and Idioms, exercise 4-1 */

#include <iostream.h>

class Engine {
public:
   Engine(int numCylinders) {}
   void start() { cout << "Engine starts.." << endl; }                
};
 
class Car1 {
public:
   Car1() : e_(8) { }            // Initializes this Car with 8 cylinders
   void start() { e_.start(); }  // Start this Car by starting its Engine
private:
   Engine e_;                    // Car has-a Engine
}; 

class Car2 : private Engine {     // Car has-a Engine
public:
   Car2() : Engine(8) { }         // Initializes this Car with 8 cylinders
   Engine::start;           // Start this Car by starting its Engine
}; 

int main() {
    Car1 c1;
    c1.start();

    Car2 c2;
    c2.start();

    return 0;
}
